package fr.free.supertos.anniversaire;

import android.app.Activity;
import android.content.Intent;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.content.pm.PackageManager.NameNotFoundException;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

/**
 * Activit A propos de ...
 * 
 * Vraiment des plus simple pour le coup !
 * 
 * @author supertos
 *
 */
public class AProposDeActivity extends Activity implements OnClickListener {
	
	private final static String CLASSE = AProposDeActivity.class.getName();
	
	private Button buttonFermer;

	private Button buttonVersion;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.a_propos_de);
		
		buttonFermer=(Button)findViewById(R.id.buttonFermer);
		buttonFermer.setOnClickListener((OnClickListener) this);
		
		buttonVersion=(Button)findViewById(R.id.buttonVersion);
		buttonVersion.setOnClickListener((OnClickListener) this);
		
		TextView textViewVersion=(TextView)findViewById(R.id.textViewVersion);
        // Rcupration de la Version positionne dans le fichier AndroidManifest.xml
		textViewVersion.setText( textViewVersion.getText() + " "+ version() );        
	}

	// onResume, mais rien de spcial  faire ici...
	public void onResume()
	{
		super.onResume();		
	}

	// gestion du click sur les boutons
	public void onClick(View view){
    	switch (view.getId())
    	{	    	
	    	case R.id.buttonFermer:
	    		finish();
	    		break;
	    		
	    	case R.id.buttonVersion:
	    		// Lancement de la page de gestions de mes applications.
	    		String url = "http://supertos.free.fr/supertos.php?name=anniversaire&version="+ version();  
	            Intent i = new Intent(Intent.ACTION_VIEW);  
	            i.setData(Uri.parse(url));  
	            startActivity(i);
	    		break;
    	}
    }
	
	// Retourne la Version positionne dans le fichier AndroidManifest.xml
	public String version(){
		PackageManager pm = getPackageManager();
      	PackageInfo pi;
      	String version="0.00";
		try {
			pi = pm.getPackageInfo( getPackageName(), 0);
			version=pi.versionName;
		} catch (NameNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return version;
	}
	}

