package fr.free.supertos.anniversaire;

import android.appwidget.AppWidgetManager;
import android.appwidget.AppWidgetProvider;
import android.content.Context;
import android.content.Intent;
import fr.free.supertos.anniversaire.log.LogAnniv;
import fr.free.supertos.anniversaire.service.ServiceUpdateAppWidget;
 
/**
 * AppWidget Anniversaire
 * 
 * Son rle est d'afficher  l'cran la liste des anniversaires du jour ou, s'il n'y en a pas, les futurs anniversaires.
 * 
 * @author supertos
 *
 */
public class AnniversaireWidget extends AppWidgetProvider {
 
    @Override
    public void onUpdate(Context context, AppWidgetManager appWidgetManager, int[] appWidgetIds) {
        final int n = appWidgetIds.length;

    	LogAnniv.d ("Widget","onUpdate pour " + n + " App Widget !");

        // Lancement du service permettant de lire la base afin de mettre  jour les appWidgets...
    	// Ici, pas de boucle pour mettre  jour les appWidgets, car tous les appWidgets Anniversaires qui seraient 
    	// poss afficheraient la mme chose.
    	// Le traitement pouvant tre long, le service suivant va effectuer les oprations dans un Thread indpendant puis 
    	// va dclencher un update sur la classe AppWidget Anniversaire pour arroser tous les AppWidgets d'un coup...
    	context.startService(new Intent(context, ServiceUpdateAppWidget.class));
    }
}