package fr.free.supertos.anniversaire;

import android.app.Activity;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ToggleButton;
import fr.free.supertos.anniversaire.bean.BeanParametres;
import fr.free.supertos.anniversaire.dao.DaoParametres;
import fr.free.supertos.anniversaire.database.SqLiteAnniversaire;
import fr.free.supertos.anniversaire.factory.DaoFactory;

/**
 * Paramtrage de la notification d'une alarme
 *  
 * @author supertos 
 *
 */
public class ParamActivityNotif extends Activity implements OnClickListener {

	private final static String CLASSE = ParamActivityNotif.class.getName();
	
	SqLiteAnniversaire sqLiteAnniv;
	SQLiteDatabase idSqLite;
	
	Button buttonValider;
	Button buttonAnnuler;
	ToggleButton toggleSon;
	ToggleButton toggleVibration;
	
	private BeanParametres bParametres;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_parametres_notif);
		
		buttonValider=(Button)findViewById(R.id.buttonValider);
		buttonValider.setOnClickListener((OnClickListener)this); 
		buttonAnnuler=(Button)findViewById(R.id.buttonAnnuler);
		buttonAnnuler.setOnClickListener((OnClickListener)this); 
		
		toggleSon=(ToggleButton)findViewById(R.id.toggleSon);
		toggleVibration=(ToggleButton)findViewById(R.id.toggleVibration);
		
		restaurerInstance(savedInstanceState);
	}

	private void restaurerInstance(Bundle savedInstanceState) {
		
		if (savedInstanceState!=null)
		{
			bParametres = new BeanParametres();
			
			bParametres.setVibration(savedInstanceState.getInt("vibration"));
			bParametres.setSon(savedInstanceState.getInt("son"));
		}
		else
		{
			sqLiteAnniv = new SqLiteAnniversaire();
			idSqLite=sqLiteAnniv.openDB(this);
			
			DaoParametres daoParametres=(DaoParametres)DaoFactory.daoParametres(idSqLite);
			bParametres=daoParametres.getParametres();

			sqLiteAnniv.closeDB (idSqLite);
		}
	}
	
	@Override
	protected void onSaveInstanceState(Bundle saveInstanceState) {

		super.onSaveInstanceState(saveInstanceState);

		saveInstanceState.putInt ("vibration", bParametres.getVibration());
	    saveInstanceState.putInt ("son", bParametres.getSon());
	}
	
	public void onResume()
	{
		super.onResume();
					
		toggleVibration.setChecked(bParametres.getVibration()==1?true:false);
		toggleSon.setChecked(bParametres.getSon()==1?true:false);

	}
	
	public void onClick(View view){
    	switch (view.getId())
    	{	    	
	    	case R.id.buttonValider:
	        	SqLiteAnniversaire sqLiteAnniv = new SqLiteAnniversaire();
	    		SQLiteDatabase idSqLite=sqLiteAnniv.openDB(this);
	    		
	    		DaoParametres daoParametre=(DaoParametres)DaoFactory.daoParametres(idSqLite);
	    		BeanParametres bParametres=new BeanParametres();
	    		bParametres.setVibration(toggleVibration.isChecked()?1:0);
	    		bParametres.setSon(toggleSon.isChecked()?1:0);
	    		daoParametre.ecrireParametresNotification(bParametres);
	    		
	    		sqLiteAnniv.closeDB (idSqLite);
	    		
	        	finish();
	    	break;

	    	case R.id.buttonAnnuler:
	    		finish();
	    	break;  	
    	}
    }
	
	public void onPause()
	{		
		super.onPause();
		
		bParametres.setVibration(toggleVibration.isChecked()?1:0);
		bParametres.setSon(toggleSon.isChecked()?1:0);
	}
	
	public void onDestroy()
	{

		super.onDestroy();
	}

}
