package fr.free.supertos.anniversaire;

import android.app.Activity;
import android.appwidget.AppWidgetManager;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import fr.free.supertos.anniversaire.log.LogAnniv;

/**
 * Activit permettant de configurer notre appWidget...
 * 
 * @author supertos
 *
 */
public class WidgetConfigureActivity extends Activity {

	private final static String CLASSE = WidgetConfigureActivity.class.getName();
    private int mAppWidgetId = AppWidgetManager.INVALID_APPWIDGET_ID;
 
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
 
        // Ne pas crer le widget si fermeture !
        setResult(RESULT_CANCELED);
 
        // Rcupration de l'id du widget
        Intent intent = getIntent();
        Bundle extras = intent.getExtras();
        if (extras != null) {
            mAppWidgetId = extras.getInt(AppWidgetManager.EXTRA_APPWIDGET_ID,
                    AppWidgetManager.INVALID_APPWIDGET_ID);
        }
 
        // Contrle la validit du widget.
        if (mAppWidgetId == AppWidgetManager.INVALID_APPWIDGET_ID) {
            LogAnniv.e(CLASSE, "L'id de l'appwidget id est invalide");
            finish();
        }
 
        configureWidget(getApplicationContext());
 
        Intent resultValue = new Intent();
        resultValue.putExtra(AppWidgetManager.EXTRA_APPWIDGET_ID, mAppWidgetId);
        setResult(RESULT_OK, resultValue);
        finish();
    }
 
    /**
     * Configuration du widget cr...
     * @param context
     */
    public void configureWidget(Context context) {
    	// Pour le moment, rien !
    }
}
