package fr.free.supertos.anniversaire.bean;

import java.util.Calendar;

import fr.free.supertos.anniversaire.constantes.ConstantesAnniversaires;

/**
 * Bean pour entit anniversaire
 * 
 * Comprend les champs suivant:
 * id: id de l'enregistrement dans l'entit anniversaire
 * idContact: id du contact correspondant (facultatif)
 * nom: nom de la personne
 * prenom: prenom de la personne
 * annee, mois et jour: date anniversaire de la personne
 * anneeConnue: pour indiquer s'il faut ou non afficher l'anne de naissance et pour permettre le calcul de l'age
 * autreEven: pour indiquer une date anniversaire autre qu'une personne
 * nomPrenom: concatnation du nom et prenom pour permettre un affichage dans un widget liste tri.
 * 
 * @author supertos
 *
 */
public class BeanAnniversaires {

	private Integer id=null; // Pas d'id par dfaut
	private long idContact;
	private String nom;
	private String prenom;
	private Integer annee;
	private Integer mois;
	private Integer jour;
	private Integer anneeConnue;
	private Integer autreEven;
	private String nomPrenom;
		
	public BeanAnniversaires() {
		idContact=-1;
		nom="";
		prenom="";
		Calendar date=Calendar.getInstance();
		annee=date.get (Calendar.YEAR);
		mois=date.get (Calendar.MONTH)+1;
		jour=date.get(Calendar.DAY_OF_MONTH);
		anneeConnue=ConstantesAnniversaires.ANNEECONNUE;
		autreEven=ConstantesAnniversaires.EVENEMENTANNIVERSAIRE;
	}
	public Integer getAnnee() {
		return annee;
	}
	public void setAnnee(Integer annee) {
		this.annee = annee;
	}
	public Integer getMois() {
		return mois;
	}
	public void setMois(Integer mois) {
		this.mois = mois;
	}
	public Integer getJour() {
		return jour;
	}
	public void setJour(Integer jour) {
		this.jour = jour;
	}
	public void setAge(Integer age) {
		this.age = age;
	}
	Integer age;
	
	public Integer getId() {
		return id;
	}
	public void setId(Integer id) {
		this.id = id;
	}
	public long getIdContact() {
		return idContact;
	}
	public void setIdContact(long idContact2) {
		this.idContact = idContact2;
	}
	public String getNom() {
		if (nom!=null)
			return nom;
		else
			return "";
	}
	public void setNom(String nom) {
		this.nom = nom;
	}
	public String getPrenom() {
		if (prenom!=null)
			return prenom;
		else
			return "";
	}
	public void setPrenom(String prenom) {
		this.prenom = prenom;
	}
	public Integer getAge() {
		return age;
	}
	public void setAge(int i) {
		age=i;
	}
	
	public void setAnneeConnue (Boolean bAnneeConnue)
	{
		anneeConnue=bAnneeConnue==true ? 1:0;
	}
	public Boolean getAnneeConnue ()
	{
		return anneeConnue==1 ? true:false;
	}
	public void setAnneeConnue(int iAnneeConnue) {
		anneeConnue=iAnneeConnue;
	}
	public Integer getIntAnneeConnue() {
		return anneeConnue;
	}
	public Integer getIntAutreEven() {
		return autreEven;
	}
	public void setAutreEven(Integer autreEven) {
		this.autreEven = autreEven;
		if (this.autreEven==1)
		{
			this.setPrenom("");
			this.setNomPrenom(this.getNom());
		}
	}
	public void setAutreEven (Boolean bAutreEven)
	{
		autreEven=bAutreEven==true ? 1:0;
		if (this.autreEven==1)
		{
			this.setPrenom("");
			this.setNomPrenom(this.getNom());
		}
	}
	public Boolean getAutreEven ()
	{
		return autreEven==1 ? true:false;
	}
	public Integer getNbJoursAvantAnniversaire()
	{
		// Maintenant effectuons un tri sur les dates, prtexte pour montrer que les classes JAVA standards fonctionnent trs bien:		
		// dterminer le timeStamp correspondant  maintenant
		long timeStampToday=System.currentTimeMillis()/1000; // On se fiche des ms

		Calendar calendar = Calendar.getInstance();

		// L'anne n'est pas intressant ici, juste le jour et le mois
		calendar.set(Calendar.DAY_OF_MONTH, this.getJour());
		calendar.set(Calendar.MONTH, this.getMois()-1);
		
		Long nbMS = calendar.getTimeInMillis()/1000; // L aussi, on se fiche des ms
		
		if (timeStampToday > nbMS)
		{
			// L'anniversaire a dj t ft ! Il faut donc ajouter une anne
			Calendar calendar1An = (Calendar) calendar.clone();
			calendar1An.set(Calendar.YEAR, calendar1An.get(Calendar.YEAR) + 1);
			nbMS = calendar1An.getTimeInMillis()/1000;
		}
		
		return (int) ((nbMS-timeStampToday)/86400); // Convertir ms/1000 en nb. de jours d'o / 86400
	}
	
	public String getNomPrenom() {
		return nomPrenom;
	}
	
	public void setNomPrenom(String nomPrenom) {
		this.nomPrenom = nomPrenom;
	}
}
