package fr.free.supertos.anniversaire.classes;

import java.io.File;
import java.io.FilenameFilter;

import fr.free.supertos.anniversaire.log.LogAnniv;

public class FiltreNom  implements FilenameFilter{
/**
 * 
 * FiltreNom pour ne filtrer que les fichiers .xml
 * 
 * Classe interne permettant de filtrer les fichiers qui sont lists.
 * 
 * @author erdup69n
 * @version 1.00
 */
   
   /**
    * Surcharge de la mthode accept standard FilenameFilter
    */
   @Override
   public boolean accept (File repFiltre, String nom)
   {   
	   File fichier = new File (repFiltre, nom);
	   
	   LogAnniv.d("FiltreNom","filtre:" + fichier.getAbsolutePath());
	   // Il ne faut dj pas retourner les rpertoires...
	   if (!fichier.isDirectory())
	   {			   
		    String extension = nom.substring(nom.lastIndexOf("."));
			if (extension.toLowerCase().contentEquals(".xml"))
			{
				return true;
			}
			else
			{
				return false;
			}

	   }
	   else
	      return false;
   }
}
