package fr.free.supertos.anniversaire.classes;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CheckBox;
import android.widget.LinearLayout;
import android.widget.SimpleAdapter;
import android.widget.TextView;
import fr.free.supertos.anniversaire.R;
import fr.free.supertos.anniversaire.constantes.ConstantesMyListAdapter;
import fr.free.supertos.anniversaire.log.LogAnniv;

/**
 * Cration personnalis d'un adaptateur pour une liste
 * @author supertos
 *
 */
public class MyListAdapter extends SimpleAdapter
{
	private final static String CLASSE = MyListAdapter.class.getName();
	
	private LayoutInflater	mInflater;

	public List<CheckBox> listCb=new ArrayList<CheckBox>(100);
	
	public List<Integer> listEtatCb=new ArrayList<Integer>(100);

	private int cbVisible = View.INVISIBLE;
	
	private int lastPosition=-1;
	
	
	public MyListAdapter (Context context, List<? extends Map<String, ?>> data,
			int resource, String[] from, int[] to)
	{
		super (context, data, resource, from, to);
		mInflater = LayoutInflater.from (context);

	}

	@Override
	public Object getItem (int position)
	{
		return super.getItem (position);
	}

	@Override
	public View getView (int position, View convertView, ViewGroup parent)
	{
		//Ce test permet de ne pas reconstruire la vue si elle est dj cre, ou
		// de la complter dans le cas ou la liste des enregistrements est plus grande que ce qui est effectivement affich
		//  l'cran. Dans ce cas, il faut ajouter ces lignes de la liste des "enregistrements" dans la liste "graphique"
		LogAnniv.d(CLASSE, "getView sur position n" + position);

		// On rcupre les lments de notre vue
		convertView = mInflater.inflate (R.layout.list_detail, null);

		// On rcupre notre checkBox
		CheckBox cb = (CheckBox) convertView.findViewById (R.id.checkBox);
		// On lui affecte un tag comportant la position de l'item afin de
		// pouvoir le rcuprer au clic de la checkbox
		cb.setTag (position);
		// Et la visibilit ou non du cb
		cb.setVisibility(cbVisible);
		// Et on s'occupe du textview
		TextView tv = (TextView) convertView.findViewById (R.id.identification);
		tv.setTextSize (cb.getTextSize());
		LinearLayout ll=(LinearLayout)tv.getParent();
		ll.setTag(position);

		if (convertView == null || position > lastPosition)
		{
			LogAnniv.d(CLASSE, "Cration CB n" + position);			
			listCb.add (cb);
			
			listEtatCb.add (ConstantesMyListAdapter.NONCOCHE);
			lastPosition=position;
		}
		else
		{
			// J'en profite pour rafraichir le contenu de la check box qui est en train de
			// s'afficher  l'cran mais aussi lors de scrolling bas/haut pour (r)afficher les lignes
			cb.setChecked(getEtatCb(position)==1?true:false);
			listCb.set(position, cb);
		}
		
		return super.getView (position, convertView, parent);
	}

	/**
	 * Montrer les combobox de la liste
	 */
	public void showCb ()
	{
		cbVisible = View.VISIBLE;
		if (LogAnniv.isDebug())
    	{
    		LogAnniv.d(CLASSE, "Show CB !");
    	}
		
		majAttributVisibleCb();
	}
	
	/**
	 * Cacher les combobox de la liste
	 */
	public void hideCb ()
	{
		cbVisible = View.INVISIBLE;
		
		majAttributVisibleCb();

	}

	private void majAttributVisibleCb()
	{
		for (CheckBox cb:listCb)
		{
			cb.setVisibility(cbVisible);
		}
	}
	
	/**
	 * Permet de modifier l'tat d'une combo dans un lment de la liste adapter
	 * 
	 * position indiquant la position de la CB dans la liste.
	 * 
	 * @param position
	 */
	public void changeEtatCb(int position) {
		CheckBox cb=listCb.get(position);
		
		if (cb.isChecked())
		{
			listEtatCb.set(position, ConstantesMyListAdapter.COCHE);
		}
		else
		{
			listEtatCb.set(position, ConstantesMyListAdapter.NONCOCHE);
		}
		
		if (LogAnniv.isDebug())
    	{
    		LogAnniv.d(CLASSE, "changeEtatCb, CB n" + position + ":" + listEtatCb.get(position));
    	}
	}

	public Integer getEtatCb(int position)
	{
		return listEtatCb.get(position);
		
	}
	
	public int getNombreCb()
	{
		return listCb.size();
	}
	
	public Integer auMoins1CbCoche()
	{
		Integer cbCoche;
		int taille=getNombreCb();
		
		if (taille > 0)
		{
			int i=0;
			
			do
			{
				cbCoche=listEtatCb.get(i++);	
			}while (i< taille && cbCoche==ConstantesMyListAdapter.NONCOCHE);
		}
		else
		{
			cbCoche=ConstantesMyListAdapter.NONCOCHE;
		}
		return cbCoche;
	}
}