package fr.free.supertos.anniversaire.dao;

import org.xmlpull.v1.XmlSerializer;

import android.content.ContentValues;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import fr.free.supertos.anniversaire.bean.BeanEtat;
import fr.free.supertos.anniversaire.log.LogAnniv;

public class DaoEtat extends DaoStandard {
	
	private final static String CLASSE = DaoEtat.class.getName();
	
	public DaoEtat(SQLiteDatabase idSqLite) {
		super(idSqLite);
	}
	
	public DaoEtat (XmlSerializer serializer) {
		super(serializer);
	}

	public BeanEtat getEtat () {	
        String [] columns=new String[]{"id,startams"};
        String [] where=new String[]{"0"};
        
        BeanEtat bEtat=new BeanEtat();
        
        Cursor cursor = idSQLiteDB.query("etat", columns, "id>=?",where,null,null,null);
        // Affichage des enregistrements
        Integer nbRecord = cursor.getCount();
        if (nbRecord > 0) // Du moins, s'il y en a !
        {               
        	cursor.moveToFirst(); // On se positionne sur le premier
            
        	if (LogAnniv.isDebug())
        	{
        		LogAnniv.d (CLASSE, "Enregistrement n" + cursor.getLong(cursor.getColumnIndex("id")) + ": ms=" + cursor.getString(cursor.getColumnIndex("startams")));
        	}        		
        	bEtat.setStartAMS(cursor.getLong(cursor.getColumnIndex("startams")));
            
            cursor.close(); // Fermeture du curseur
        }
        else
        {
        	// problme, il n'y en a pas !
        	// Cration d'un bean par dfaut !
        	bEtat.setStartAMS(0);
        	
        	LogAnniv.w (CLASSE, "Table etat: record anormalement absent, ...");
        	
    		ContentValues cv = new ContentValues();
    		// Cration de paramtres par dfaut
    		cv.put ("startams", "0");
    		
    		idSQLiteDB.insert("etat", null, cv);
        }
        
        if (nbRecord > 1)
        	LogAnniv.w (CLASSE, "Table etat: nb. records anormalement suprieur  1, le premier est pris." + nbRecord);
        return bEtat;
	}

	public void ecrireEtat(BeanEtat bEtat) {
		ContentValues cv = new ContentValues();

		LogAnniv.i (CLASSE, "Table etat: sauve" + bEtat.getStartAMS() + "...");
		
		cv.put("startams", bEtat.getStartAMS());

		idSQLiteDB.update("etat", cv, null, null);
	}
}
