package fr.free.supertos.anniversaire.database;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import fr.free.supertos.anniversaire.log.LogAnniv;

public class SqLiteAnniversaire {

	private final static String CLASSE = SqLiteAnniversaire.class.getName();
	private final static String DB_NAME = "DBAnniversaire";
	private final static Integer DB_VERSION = 1;
	
	/**
	 * Ouverture d'une base de donne SqLite.
	 * Utilisation de SQLiteOpenHelper via AnnivSqLiteOpenHelper pour crer/modifier la base de donnes si ncessaire.
	 * 
	 * @param contexte
	 * @return identifiant de la base de donnes
	 */
	public SQLiteDatabase openDB (Context contexte) {

		if (LogAnniv.isInformation())
		{
			LogAnniv.i (CLASSE, "openDB...");
		}
        if (LogAnniv.isDebug())
        {
        	LogAnniv.d (CLASSE, "Cration d'une instance mySQLiteOpenHelper");
        }
        AnnivSqLiteOpenHelper mySQLiteOpenHelper = new AnnivSqLiteOpenHelper (contexte, 
        		/* Nom de la base */
        		DB_NAME,
        		/* Curseurs par dfaut */
        		null,
        		/* Version */
        		DB_VERSION);
        
        if (LogAnniv.isDebug())
        {
        	LogAnniv.d (CLASSE, "Rcupration d'un identifiant sur la DB");
        }
        SQLiteDatabase idSQLiteDB = mySQLiteOpenHelper.getWritableDatabase ();
        if (LogAnniv.isInformation())
        {
        	LogAnniv.i (CLASSE, "ID DataBase:" + idSQLiteDB);
        }
        
        return idSQLiteDB;
    }
	
	/**
	 * Fermeture de la base de donnes SQLite
	 * @param idSQLiteDB
	 */
	public void closeDB (SQLiteDatabase idSQLiteDB)
	{	
		if (LogAnniv.isInformation())
        {
			LogAnniv.i (CLASSE, "Fermeture ID DataBase:" + idSQLiteDB);
        }
		idSQLiteDB.close();
	}
}
