package fr.free.supertos.anniversaire.factory;

import org.xmlpull.v1.XmlSerializer;

import android.database.sqlite.SQLiteDatabase;
import fr.free.supertos.anniversaire.dao.DaoAnniversaires;
import fr.free.supertos.anniversaire.dao.DaoEtat;
import fr.free.supertos.anniversaire.dao.DaoParametres;
import fr.free.supertos.anniversaire.dao.DaoStandard;

/**
 * Factory de DAO
 * 
 * DaoAnniversaires pour usage bdd ou xml
 * idem pour DaoParametres ou DaoEtat
 * @author supertos
 *
 */
public class DaoFactory {

	public static DaoStandard daoAnniversaires(SQLiteDatabase idSqLite)
	{
		return new DaoAnniversaires (idSqLite);
	}
	
	public static DaoStandard daoAnniversaires(XmlSerializer serializer)
	{
		return new DaoAnniversaires (serializer);
	}

	public static DaoStandard daoParametres(SQLiteDatabase idSqLite)
	{
		return new DaoParametres (idSqLite);
	}
	
	public static DaoStandard daoParametres(XmlSerializer serializer)
	{
		return new DaoParametres (serializer);
	}
	
	public static DaoStandard daoEtat(SQLiteDatabase idSqLite)
	{
		return new DaoEtat (idSqLite);
	}

	public static DaoStandard daoEtat(XmlSerializer serializer)
	{
		return new DaoEtat (serializer);
	}
}
